;XIncludeFile "RMChart.pbi"
;RMC_Init()

Enumeration 1 ; Windows
  #ID_WINDOW
EndEnumeration

Enumeration #WM_USER+1024 ; Charts
  #ID_CHART
EndEnumeration

Enumeration 1 ; Regions
  #ID_REGION
EndEnumeration

Procedure Test()
  If RMC_CreateChart(WindowID(#ID_WINDOW), #ID_CHART, 0, 0, 800, 600) = #RMC_NO_ERROR
    Debug "1"
    RMC_AddRegion(#ID_CHART, 5, 5, -5, -5,"Test")
    RMC_AddGrid(#ID_CHART, #ID_REGION)
    RMC_AddXAxis(#ID_CHART, #ID_REGION, #RMC_XAXISBOTTOM)
    RMC_AddYAxis(#ID_CHART, #ID_REGION, #RMC_YAXISLEFT)
    RMC_AddXYSeries(#ID_CHART, #ID_REGION, ?LabX, 10, ?LabY, 10, #Black, #RMC_XY_LINE, #RMC_LSTYLE_SPLINE,0,0,0,0)
    RMC_SetCaptionBGColor(#ID_CHART,#ID_REGION,0)
    RMC_Draw(#ID_CHART)
  EndIf
EndProcedure

Procedure MyCallback(hWnd, CBMSG, CBWPARAM, CBLPARAM)
  Protected *TINFO.RMC_INFO
  Protected CBCTL.w,CBCTLMSG.w
  Protected Text$
  Static z.l
  
  CBCTL = PeekW(@CBWPARAM+0)
  CBCTLMSG = PeekW(@CBWPARAM+2)
  
  Select CBMSG
    Case #WM_RBUTTONDOWN  ; right mouse button was clicked
      ; CBLPARAM holds always the X/Y-position within the dialog,
      ; even you've clicked onto the chart
      Text$="X-Pos in the dialog:"+Str(PeekW(@CBLPARAM+0))+Chr(13)
      Text$+"Y-Pos in the dialog:"+Str(PeekW(@CBLPARAM+2))
      MessageRequester("RMChart",Text$,0)
    Case #WM_COMMAND
      Select CBCTL
        Case #ID_CHART                     ;message from the chart control
          Select CBCTLMSG                  ;identify the message
            Case #RMC_LBUTTONDOWN          ;left mouse button
              z = 1                        ;set flag for left mouse button pressed
            Case #RMC_LBUTTONUP
              z = 0                        ;reset the flag for left mouse button pressed
            Case #RMC_CTRLRBUTTONDOWN      ;Ctrl and right mouse button
              *TINFO = CBLPARAM            ;CBLPARAM holds a pointer to a tRMC_INFO structure
              Text$="X-Pos in the chart:"+Str(*TINFO\nXPos)+Chr(13)
              Text$+"Y-Pos in the chart:"+Str(*TINFO\nYPos)
              MessageRequester("RMChart",Text$,0)
            Case #RMC_MOUSEMOVE            ;mouse was moved in the chart control
              *TINFO = CBLPARAM            ;CBLPARAM holds a pointer to a tRMC_INFO structure
              If z                         ;if the left mouse button is pressed
                ;move the chart control within your dialog
                RMC_SetCtrlPos(#ID_CHART,*TINFO\nXMove,*TINFO\nYMove,1)
              EndIf
          EndSelect
      EndSelect
  EndSelect
  
  ProcedureReturn #PB_ProcessPureBasicEvents
EndProcedure

Procedure PBMain()
  If OpenWindow(#ID_WINDOW, 0, 0, 800, 600, "RMCHART.DLL", #PB_Window_SystemMenu|#PB_Window_ScreenCentered)
    Test()
    
    SetWindowCallback(@MyCallback())
    
    Repeat
     Event=WaitWindowEvent() 
     
     Select Event
       Case #PB_Event_Gadget
         ;Debug "Gadget "+Str(EventGadget())
         Select EventGadget()
         EndSelect
     EndSelect
    Until Event=#PB_Event_CloseWindow
    
    CloseWindow(#ID_WINDOW)
    
  EndIf
EndProcedure

PBMain()

DataSection
LabX: Data.d 10,20,20,30,40,50,60,70,80,90
LabY: Data.d 10,20,30,30,30,40,90,65,80,10
EndDataSection

; IDE Options = PureBasic 4.20 Beta 2 (Windows - x86)
; CursorPosition = 11
; Folding = -